#include <ESP8266WiFi.h>  //подключаем библиотеку
#include <PubSubClient.h> // устанавливаем клиент/библиотеку
#include <HX711.h>        //подключение библиотеку весов
#include <GyverTM1637.h>  //подключаем библиотеку дисплея
#include <Arduino.h>

#define DT D6  // Указываем номер вывода, к которому подключен вывод DT весов
#define SCK D5 // Указываем номер вывода, к которому подключен вывод SCK весов  (нужен аналоговый пин)                                  //подключение библиотеки дисплея
#define CLK D2 //Указываем номер вывода, к которому подключен вывод CLK дисплея
#define DIO D3 //Указываем номер вывода, к которому подключен вывод DIO дисплея
GyverTM1637 disp(CLK, DIO);
HX711 scale;
int calibration_factor = 3.86; // калибровка датчика (записать нужное значение)
int units;
int ounces; //переменная со значением из весов

#define MQTT_client "mosquitto";                             // название MQTT клиента
const char *ssid = "Leo";                                    // название точки достпа
const char *pass = "Leoxxleo";                               // Пароль от точки доступа                                                           // настройки для MQTT брокера
const char *mqtt_server = "leo-HP-250-G6-Notebook-PC.local"; // адрес сервера MQTT
const int mqtt_port = 1883;                                  // Порт для подключения к серверу MQTT
const char *mqtt_user = "mosquitto";                         // Логин от сервера MQTT
const char *mqtt_pass = "mosquitto";                         // Пароль от сервера MQTT
const char *scales = "scales";                               // топик для данных

WiFiClient wclient; //инициализируем MQTT клиент
PubSubClient client(wclient);

void setup()
{
    Serial.begin(115200); //значение монитора порта
    WiFi.begin(ssid, pass);
    while (WiFi.status() != WL_CONNECTED) // если нет соединения
    {
        delay(500);
        Serial.println("Connecting to WiFi.."); //подключение к WiFi
    }
    Serial.print("Connected to WiFi :");
    Serial.println(WiFi.SSID());
    client.setServer(mqtt_server, mqtt_port);

    client.connect("node", mqtt_user, mqtt_pass); //инициализация пользователя
    while (!client.connected())
    {
        Serial.println("Connecting to MQTT..."); //подключение к MQTT
        if (client.connect("ESP8266"))
        {
            Serial.println("connected");
        }
        else
        {
            Serial.print("failed with state ");
            Serial.println(client.state());
            delay(2000);
        }
    }
    scale.set_scale();
    scale.tare();                        // сбрасываем датчик на 0
    scale.set_scale(calibration_factor); // применяем калибровку

    disp.clear();       //очищаем дисплей
    disp.brightness(4); //выставляем яркость дисплея (4)
}

void loop()
{

    client.publish(scales, String(ounces).c_str(), true); //отправляем данные с весов на сервер
    for (int i = 0; i < 10; i++)                          // усредняем показания, считав значения датчика 10 раз
    {
        units = +scale.get_units(), 10; // суммируем показания 10 замеров
    }
    units = units / 10;  // усредняем показания, разделив сумму значений на 10
    ounces = units * 10; // переводим вес из унций в граммы

    disp.displayInt(ounces); //выводим значение на дисплей
}